﻿Imports System.Globalization

Public Class BirthdayConverter
    Implements IValueConverter

    Public Function Convert(value As Object, targetType As Type,
                            parameter As Object,
                            language As String) As Object Implements IValueConverter.Convert
        Dim [date] As DateTime = value

        Dim cultureInfo As CultureInfo

        If String.IsNullOrEmpty(language) Then
            cultureInfo = CultureInfo.CurrentCulture
        Else
            cultureInfo = New CultureInfo(language)
        End If

        Dim birthday = [date].ToString("d", cultureInfo)

        Return birthday
    End Function

    Public Function ConvertBack(value As Object,
                   targetType As Type, parameter As Object,
                   language As String) As Object Implements IValueConverter.ConvertBack

        Dim cultureInfo As CultureInfo

        If String.IsNullOrEmpty(language) Then
            cultureInfo = CultureInfo.CurrentCulture
        Else
            cultureInfo = New CultureInfo(language)
        End If

        Return DateTime.Parse(value, cultureInfo)
    End Function

End Class
