﻿Imports Windows.Storage
Imports Windows.Storage.Pickers
Imports Windows.Storage.Streams

Public NotInheritable Class MainPage
    Inherits Page

    Public Sub New()
        InitializeComponent()

        stretchMode.ItemsSource = [Enum].GetNames(GetType(Stretch))
        stretchMode.SelectedIndex = 0
    End Sub

    Private Sub stretchMode_SelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        Dim str As Stretch

        str = [Enum].Parse(GetType(Stretch), stretchMode.SelectedValue)
        image.Stretch = str
    End Sub

    Private Async Sub OpenFile_Click(sender As Object, e As RoutedEventArgs)
        Dim openPicker As FileOpenPicker = New FileOpenPicker

        openPicker.SuggestedStartLocation = PickerLocationId.PicturesLibrary
        openPicker.ViewMode = PickerViewMode.Thumbnail

        For Each extension In New List(Of String)(New String() {".bmp", ".png", ".jpg", ".jpeg"})
            openPicker.FileTypeFilter.Add(extension)
        Next

        Dim file As StorageFile

        file = Await openPicker.PickSingleFileAsync()

        If Not file Is Nothing Then

            Using stream As IRandomAccessStream = Await file.OpenAsync(FileAccessMode.Read)

                Dim bitmap As BitmapImage = New BitmapImage()
                bitmap.SetSource(stream)
                image.Source = bitmap

            End Using
        End If

    End Sub
End Class
