﻿Imports System.Reflection
Imports Windows.UI.Xaml.Documents

Public NotInheritable Class MainPage
    Inherits Page

    Sub New()

        InitializeComponent()

        Dim list As IEnumerable(Of PropertyInfo)
        list = GetType(Typography).GetTypeInfo().DeclaredProperties

        For Each prop In list
            Dim item As ComboBoxItem = New ComboBoxItem()
            item.Content = prop.Name.Replace("Property", "")

            typo.Items.Add(item)
        Next

        typo.SelectedIndex = 0

    End Sub

    Private Class Method
        Public Property MethodInfo As MethodInfo
        Public Property ParameterTypes As Type()
    End Class

    Private Sub typo_SelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        Dim item As ComboBoxItem = typo.SelectedValue

        Dim method As Method

        If item.Tag Is Nothing Then
            Dim prop = item.Content
            Dim list As IEnumerable(Of MethodInfo)
            list = GetType(Typography).GetRuntimeMethods().
                    Where(Function(m) m.Name = "Set" + prop)

            Dim methodInfo As MethodInfo = list.First()

            method = New Method With {
            .MethodInfo = methodInfo
        }

            item.Tag = method
        Else
            method = item.Tag
        End If

        param.Items.Clear()

        Dim pars As ParameterInfo() = method.MethodInfo.GetParameters()
        Dim types(2) As Type

        types(0) = pars(0).ParameterType
        types(1) = pars(1).ParameterType

        method.ParameterTypes = types

        If types(1) Is GetType(Boolean) Then
            param.Items.Add(Boolean.TrueString)
            param.Items.Add(Boolean.FalseString)
        ElseIf types(1) Is GetType(Integer) Then
            param.Items.Add(0)
            param.Items.Add(1)
            param.Items.Add(2)
            param.Items.Add(3)
        Else
            Dim enums()
            enums = [Enum].GetNames(types(1))

            For Each enumItem In enums
                param.Items.Add(enumItem)
            Next
        End If

        param.SelectedIndex = 0

    End Sub

    Private Sub param_SelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        If param.SelectedIndex = -1 Then
            Return
        End If

        Dim item = typo.SelectedItem
        Dim method As Method = item.Tag

        Dim value As Object = param.SelectedItem.ToString()

        If method.ParameterTypes(1) Is GetType(Boolean) Then
            value = Boolean.Parse(value)
        ElseIf method.ParameterTypes(1) Is GetType(Integer) Then
            value = Integer.Parse(value)
        Else
            value = [Enum].Parse(method.ParameterTypes(1), value)
        End If

        Dim run As Run = New Run With {
        .Text = input.Text
    }

        method.MethodInfo.Invoke(run, New Object() {run, value})

        text.Inlines.Clear()
        text.Inlines.Add(run)

    End Sub
End Class
