﻿Imports Windows.Storage
Imports Windows.Storage.Streams

Public NotInheritable Class MainPage
    Inherits Page

    Private Async Sub ListView_ItemClick(sender As Object, e As ItemClickEventArgs)
        [progress].Visibility = Visibility.Visible
        progress.IsActive = True

        [popup].IsOpen = True
        popup.VerticalOffset = 20 + scroller.VerticalOffset

        Dim item As PictureLibrary.Image = e.ClickedItem

        Dim image = New BitmapImage

        Dim f As StorageFile = Await StorageFile.GetFileFromPathAsync(item.Path)

        Using fileStream As IRandomAccessStream = Await f.OpenAsync(FileAccessMode.Read)
            image.SetSource(fileStream)

            fullImage.Width = Me.ActualWidth - 100
            fullImage.Height = Me.ActualHeight - 100
            fullImage.Source = image
        End Using

        Dim properties As FileProperties.ImageProperties = Await f.Properties.GetImagePropertiesAsync()

        details.Text = $"aufgenommen am {properties.DateTaken}, Breite: {properties.Latitude}, Länge: {properties.Longitude}"

        Await Task.Delay(TimeSpan.FromSeconds(1))
        progress.Visibility = Visibility.Collapsed
        progress.IsActive = False
    End Sub
End Class
